<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Initial Data Annotes</TITLE>
<link href="suif1_76.html" rel=Next>
<link href="suif1_74.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_74.html">previous</A>, <A HREF="suif1_76.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC75" HREF="suif1_toc.html#TOC75">Initial Data Annotations</A></H3>
<P>
<A NAME="IDX560"></A>
<A NAME="IDX561"></A>
<A NAME="IDX562"></A>

</P>
<P>
Variables that are not in the automatic storage class can be initialized
by attaching annotations to their definitions (see section <A HREF="suif1_58.html#SEC58">Variable Definitions</A>).  These annotations are very low-level.  Each one
specifies the initial value for a certain number of bits.  Multiple
annotations may be used, in which case their order is significant.

</P>
<DL COMPACT>

<DT><CODE>k_fill</CODE>
<DD>
<A NAME="IDX563"></A>
This annotation indicates that the variable should be initialized with
<CODE>N</CODE> bits filled with bit pattern <CODE>V</CODE>, where <CODE>N</CODE> is the
first entry on the list and <CODE>V</CODE> is the second.  The size must be a
multiple of the byte size and the bit pattern must be one byte long.
Currently, zero is the only bit pattern that is supported.

<DT><CODE>k_repeat_init</CODE>
<DD>
<A NAME="IDX564"></A>
This is a generalized version of the <CODE>fill</CODE> annotation.  The
variable is initialized to <CODE>R</CODE> copies of <CODE>N</CODE> bits holding the
value <CODE>V</CODE>, where <CODE>R</CODE>, <CODE>N</CODE>, and <CODE>V</CODE> are the first,
second, and third entries on the <CODE>immed</CODE> list.  The values that are
currently supported are integers, floating point values, and symbolic
addresses.

<DT><CODE>k_multi_init</CODE>
<DD>
<A NAME="IDX565"></A>
This is another initial value annotation that is used to initialize
character strings.  The first entry on the list is the size in bits of
each character.  The rest of the entries on the <CODE>immed</CODE> list are
integers that specify the characters in the string.
</DL>

<P>
Despite the low-level nature of the initial data annotations, SUIF still
requires that they correspond to the types of the variables.  For
example, character strings should only be used to initialize character
arrays.  Each value specified in one of these annotations must fit
exactly into the corresponding variable, field, or array element.  The
only exception to this is that multiple fields or array elements may be
initialized to zero with a single <CODE>fill</CODE> annotation.

</P>
<P>
For example, this structure

</P>

<PRE>
struct {
    int x[2];
    float fp;
    char string[7];
} sample;
</PRE>

<P>
might be initialized with the following annotations:

</P>

<PRE>
["fill": 64 0]
["repeat_init": 1 32 1.2000e+00]
["multi_init": 8 102 97 116 112 105 103 0]
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_74.html">previous</A>, <A HREF="suif1_76.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
